{$A+,B-,D+,E+,F-,G+,I+,L+,N+,P+,Q-,R-,S-,T-,V+,X+,Y+}

{TESTGUI
 -------
(C) 1998,1999,2000 by Arsne von Wyss - arsene@vonwyss.ch

Rev: 20000214

This source code is freeware for non-commercial use and provided AS-IS.
You are not allowed to use or spread incomplete (inclusive this header)
copies of this code. Use at your own risk. If you do not agree with these
statements, delete this source code immediately. Please contact the
author via email for questions or bug reports.

Experimental GUI test application.

IMPORTANT NOTES
---------------
* currently MCGA, VBE, GX1, GX2 and GHX support bitmaps
* BGI will work but not display bitmaps
* GX1 (GrafX 1.4) driver will not work in PM (crash)
* GHX (Graphix 7.xx) driver is maintained by Michael Knapp}

{$DEFINE SELECTDRIVER}
{$DEFINE VESA}{VESA native banked driver} {-> reference driver; RM & PM}
{ $DEFINE GX1} {GrafX 1.4}                 {8 bit, crashes in PM}
{ $DEFINE GX2} {GrafX 2}                   {good driver, only PM}
{ $DEFINE GHX} {GraphiX 7.x}               {ok, but looses 65k of memory}
{ $DEFINE BGI} {Borland Graphic Interface} {no bitmaps, 16 colors :-( }

{ $DEFINE MODAL}        {show modal dialog first}
{ $DEFINE TRUETYPE}     {also use TrueType font [see FONTS.PAS]}
{$DEFINE SMALLFNT}     {use SMALL.FNT bitmap font}
{$DEFINE BITMAP}       {use bitmap COLORS.BMP as background}
{ $DEFINE BUSY}         {draw shapes when idle}
{ $DEFINE NOPRIMITIVES} {only draw complex shapes}
{ $DEFINE ONLYFILL}     {only draw filles shapes}
{ $DEFINE VSYNC}        {wait for vertical retrace when drawing}
{ $DEFINE MULTITASK}    {return time slices to OS}
{ $DEFINE SHOWMEM}      {display memory in infobar and summary at end}
{ $DEFINE DRAGMENU}     {allow menu to be dragged on the screen}

uses
	Objects,GUI,GUIUtils,Elements,Events,Dialogs,
	{$IFDEF DPMI}{$IFDEF GX2}Drv_GX2,{$ENDIF}{$IFDEF GHX}Drv_GHX,{$ENDIF}{$ENDIF}
	{$IFNDEF DPMI}{$IFDEF GX1}Drv_GX1,{$ENDIF}{$ENDIF}Drv_MCGA,{$IFDEF BGI}Drv_BGI,{$ENDIF}{$IFDEF VESA}Drv_VBE,{$ENDIF}
	{$IFDEF DEBUG}Surfaces,{$ENDIF}Canvas,Fonts,Bitmaps,Menus;

const
	RoundBorder=7;
	AlphaFill=$00 shl 24;
	cmChangeEnabled=400;
	cmCloseFocus=401;

type
	PApp=^TApp;
	TApp=object(TApplication)
		PanelLabel: PLabel;
		ListBox: PListBox;
		Dialog: PDialog;
		Desktop: PPanel;
		constructor Init;
		procedure HandleEvent(var Event: TEvent); virtual;
		procedure Idle; virtual;
		destructor Done; virtual;
	end;

function IntToStr(I: Integer): string;
var
	Result: string;
begin
	Str(I,Result);
	IntToStr:=Result;
end;

constructor TApp.Init;
var
	Window: PWindow;
	View: PView;
	Panel: PPanel;
	MenuBar: PMenuBar;
	I,J,X,Y: Integer;
	F: File;
	{$IFDEF BITMAP}
	Bitmap: PBitmap;
	{$ENDIF}
begin
	inherited Init(nil);
	{$IFDEF SMALLFNT}
	FileMode:=2;
	Assign(F,'SMALL.FNT');
	Reset(F,1);
	BlockRead(F,PFont8(SystemFont)^.Data,SizeOf((PFont8(SystemFont)^.Data)));
	Close(F);
	{$ENDIF}
	{$IFDEF TRUETYPE}
	Screen^.Canvas^.Font:=New(PTrueTypeFont,Init('C:\WINDOWS\FONTS\ARIAL.TTF'{'TESTFONT.TTF'}));
	PTrueTypeFont(Screen^.Canvas^.Font)^.SetSize(70);
{	SystemFont:=Screen^.Canvas^.Font;}
	{$ENDIF}
	MenuBar:=New(PMenuBar,Init(Screen));
	with MenuBar^ do begin
		Resize(Screen^.Width,Canvas^.Font^.Height+4);
		with AddPopup('File',nil,True)^.Menu^ do begin
			AddItem('Open',nil,True,0)^.Enabled:=False;
			AddItem('Close',nil,True,cmCloseFocus);
			AddItem('',nil,True,0);
			with AddPopup('Recent files',nil,True)^.Menu^ do begin
				AddItem('File 1',nil,True,0);
				AddItem('File 2',nil,True,0);
				with AddPopup('Another menu popup',nil,True)^.Menu^ do begin
					AddItem('File 3',nil,True,0);
					AddItem('File 4',nil,True,0);
					AddItem('File 5',nil,True,0);
				end;
				AddItem('File 6',nil,True,0);
			end;
			AddItem('',nil,True,0);
			AddItem('Quit TestGUI',nil,True,cmClose);
		end;
		with AddPopup('Edit',nil,True)^.Menu^ do begin
			AddItem('Cut',nil,True,0);
			AddItem('Copy',nil,True,0);
			AddItem('Paste',nil,True,0);
			AddItem('Delete',nil,True,0);
		end;
		AddItem('Single Item',nil,True,0);
		SetEventHandler(self.Handle);
		Show;
	end;
	New(Desktop,Init(Screen));
	with Desktop^ do begin
		Move(0,MenuBar^.Height);
		Resize(Screen^.Width,Screen^.Height-Top);
		BorderWidth:=0;
		UniqueColorSet;
		ColorSet^.Back:=ColorSet^.Special;
		Show;
	end;
	{$IFDEF DRAGMENU}
	with PView(New(PMover,Init(MenuBar)))^ do begin (* Move-Handle on MenuBar *)
		Resize(Owner^.Width,Owner^.Height-1);
		ResizeFlags:=[rfRight,rfBottom];
		Canvas^.SetColor(Owner^.Canvas^.GetColor);
		MoveToBottom;
		Show;
	end;
	{$ENDIF}
	{$IFDEF BITMAP}
	Bitmap:=New(PGenericBitmap,Init);
	PGenericBitmap(Bitmap)^.LoadBMP('METAL.BMP');
	Screen^.ConvertBitmap(Bitmap);
	{$ENDIF}
	with PClockLabel(New(PClockLabel,Init(MenuBar)))^ do begin
		AlwaysOnTop:=True;
		MoveToTop;
		Resize(70,9);
		Move(Owner^.Width-Width,2);
		Show;
	end;
	New(Panel,Init(Screen));
	with Panel^ do begin
		Move(5,Screen^.Height-28);
		Resize(Screen^.Width-10,21);
		Show;
	end;
	Panel^.AlwaysOnTop:=True;
	PanelLabel:=PLabel(New(PLabel,Init(Panel)));
	with PanelLabel^ do begin
		Move(1,1);
		Resize(Panel^.Width-2,Panel^.Height-2);
		SetCaption('Mouse: L=Activate, R=Get Focus, L+R=Quit=[Alt-X]'#13#10+'(C) 1999 by Arsne von Wyss - arsene@vonwyss.ch');
		Show;
	end;
	for I:=1 to 10 do begin
		New(Window,Init(Desktop));
		with Window^ do begin
			Move(I*16,I*16);
			Resize(200,16*I+19);
			SetTitle('Window '+IntToStr(I));
			for J:=0 to I-1 do
				with PButton(New(PButton,Init(Window)))^ do begin
					Move(1,J*16+1);
					Resize(190,14);
					SetCaption('Button '+IntToStr(J+1)+' in Window '+IntToStr(I));
					ResizeFlags:=[rfRight];
{					Hover:=True;}
					Show;
				end;
			{$IFDEF BITMAP}
			SetBackground(Bitmap);
			{$ENDIF}
			Show;
		end;
	end;
	PScrollBox(Window^.Surface)^.ShowScrollBars(True,False);
	New(PFileSelector(Dialog),Init(Desktop));
	PFileSelector(Dialog)^.Move(10,10);
	PFileSelector(Dialog)^.SetTitle('File Selector'{$IFDEF MODAL}+' - Modal (must be closed to release windows)'{$ENDIF});
{	PFileSelector(Dialog)^.Files^.Surface^.Canvas^.Font:=Screen^.Canvas^.Font;}
	PFileSelector(Dialog)^.SetDir('C:\');
	Dialog^.{$IFDEF MODAL}ShowModal{$ELSE}Show{$ENDIF};
	Screen^.Canvas^.SetColor($007580); {desktop color similar to the "Windows blueish"}
{	Screen^.AutoFocus:=True;} (* UNIX-like focusing when under mouse *)
	if RoundBorder>0 then (* make round screen edges *)
		with PSurfaceCanvas(New(PSurfaceCanvas,Init(Screen)))^ do begin
			SetColor(0);
			Bar(0,0,RoundBorder,RoundBorder);
			Bar(Width-Succ(RoundBorder),Height-1,Width-1,Height-Succ(RoundBorder));
			Bar(Width-Succ(RoundBorder),0,Width-1,RoundBorder);
			Bar(0,Height-Succ(RoundBorder),RoundBorder,Height-1);
			SetColor(1);
			Disc(RoundBorder,RoundBorder,RoundBorder);
			Disc(Width-Succ(RoundBorder),RoundBorder,RoundBorder);
			Disc(RoundBorder,Height-Succ(RoundBorder),RoundBorder);
			Disc(Width-Succ(RoundBorder),Height-Succ(RoundBorder),RoundBorder);
			Free;
		end;
	Screen^.SetEventHandler(Handle);
	{$IFDEF BITMAP}
	with Desktop^ do begin
		Background:=New(PGenericBitmap,Init);;
		PGenericBitmap(Background)^.LoadBMP('BACK.BMP');
		Screen^.ConvertBitmap(Background);
	end;
	with Panel^ do begin
		Background:=New(PGenericBitmap,Init);;
		PGenericBitmap(Background)^.LoadBMP('COLORS.BMP');
		Screen^.ConvertBitmap(Background);
	end;
	Dialog^.SetBackground(Bitmap);
	Bitmap^.Free;
	{$ENDIF}
end;

procedure TApp.HandleEvent(var Event: TEvent);
var
	C: Longint;
	Act: PView;
begin
	with Event do begin
		if What=evCommand then
			case Command of
			cmClose: Halt;
			cmHandleKey: if KeyCode=kbAltX then
					Halt;
			cmChangeEnabled:
				with PView(InfoPtr)^ do
					if Enabled then
						Disable
					else
						Enable;
			cmCloseFocus: begin
					Act:=Screen^.Focus;
					while Assigned(Act) and (Act^.Owner<>PViewGroup(Screen)) do
						Act:=Act^.Owner;
					if Assigned(Act) then
						Send.Command(Act^.Handle,cmClose,0);
				end;
			500: with Screen^.Canvas^ do begin
					Clear;
					GotoXY(500,2);
					C:=GetColor;
					SetColor(clBlack);
					Write(Event.InfoInt);
					SetColor(C);
				end;
			end;
	end;
end;

procedure TApp.Idle;
{$IFDEF BUSY}
const
	FilledSkip={$IFDEF ONLYFILL}1{$ELSE}10{$ENDIF};
var
	Points: array[0..31] of TPoint;
	Cnt: Integer;
	procedure GenPoints(Bez: Boolean);
	var
		I: Integer;
	begin
		Cnt:=Random(High(Points)-2)+3;
		if Bez then
			Cnt:=Minimum(31,Maximum(7,(Cnt div 2)*3+1));
		for I:=0 to Pred(Cnt) do
			with Points[I] do begin
				X:=Random(Screen^.Width);
				Y:=Random(Screen^.Height);
				if Bez and (I mod 3=1) and (I>3) then begin
					Points[I-2].X:=2*Points[I-1].X-X;
					Points[I-2].Y:=2*Points[I-1].Y-Y;
				end;
			end;
		if Bez then begin
			Points[0]:=Points[Cnt-1];
			Points[1].X:=2*Points[Cnt-1].X-Points[Cnt-2].X;
			Points[1].Y:=2*Points[Cnt-1].Y-Points[Cnt-2].Y;
			Cnt:=(Cnt+2) div 3;
		end;
	end;
{$ENDIF}
{$IFDEF SHOWMEM}
var
	S: string;
{$ENDIF}
begin
	with Desktop^,Canvas^ do begin (* uncomment for some screen drawing action *)
		{$IFDEF VSYNC}
		asm (* VSync to prevent mouse flickering *)
			mov dx,3dah;@a:in al,dx;test al,1;jnz @a;@b:in al,dx;test al,8;jz @b
		end;
		{$ENDIF}
		{$IFDEF BUSY}
		SetColor(AlphaFill or RandomColor);
		case Random({$IFDEF NOPRIMITIVES}2{$ELSE}5{$ENDIF}) of
		0: begin
				GenPoints(False);
				if Random(FilledSkip)=0 then
					PolyFill(Points,Cnt)
				else
					PolyLine(Points,Cnt);
			end;
		1: begin
				GenPoints(True);
				if Random(FilledSkip)=0 then
					PolyBezierFill(Points,Cnt)
				else
					PolyBezierLine(Points,Cnt);
			end;
		2: if Random(FilledSkip)=0 then
				FillEllipse(Random(Width),Random(Height),Random(Width div 3),Random(Height div 3),Random*2*Pi)
			else
				Ellipse(Random(Width),Random(Height),Random(Width div 3),Random(Height div 3),Random*2*Pi);
		3: Bar(Random(Width),Random(Height),Random(Width),Random(Height));
		4: Disc(Random(Width),Random(Height),Random(Height div 3));
		end;
		{$DEFINE RESTCOL}
		{$ENDIF}
		{$IFDEF TRUETYPE}
		SetColor(Longint(Random(256)) shl 16+Random(256) shl 8+Random(256));
		if (Mouse^.Keys<>0) and UnderMouse then begin
			SetColor(GetColor xor $FFFFFF);
			GotoXY(Mouse^.Position.X,Mouse^.Position.Y);
			Alignment:=taCentered;
			WriteLn('TrueType');
			WriteLn('font support');
		end;
		{$DEFINE RESTCOL}
		{$ENDIF}
		{$IFDEF RESTCOL}
		SetColor($007580);
		{$ENDIF}
	end;
	if (Mouse^.Keys=3) or (Mem[Seg0040:$0017] and 3=3) then
		Halt;
	{$IFDEF SHOWMEM}
	Str(MemAvail,S);
	PanelLabel^.SetCaption('Free memory: '+S+' bytes');
	{$ENDIF}
	{$IFDEF MULTITASK}
	if IdleTime>=100 then
		asm (* Release time slice under DOS, Windows and OS/2 after 100ms without mouse/key activity*)
			MOV AX,$1680
			INT $2F
		end;
	{$ENDIF}
end;

destructor TApp.Done;
begin
	{$IFDEF TRUETYPE}
	Screen^.Canvas^.Font^.Free;
	{$ENDIF}
	inherited Done;
end;

{$IFDEF SELECTDRIVER}
procedure SelectDriver;
var
	I: Integer;
begin
	WriteLn('Available drivers:');
	WriteLn('');
	WriteLn('1: MCGA         (320*200, 8 Bit, RGB palette)    [LOWRES, reference driver #1]');
{$IFDEF BGI}{$DEFINE SELECT}WriteLn('2: BGI          (640*480, 4 Bit, system palette) [SLOW, no bitmaps]');{$ENDIF}
	{$IFNDEF DPMI}
{$IFDEF GX1}{$DEFINE SELECT}WriteLn('3: GrafX1.4     (800*600, 8 Bit, RGB palette)    [OK, unstable in PM]');{$ENDIF}
	{$ELSE}
{$IFDEF GX2}{$DEFINE SELECT}WriteLn('4: GrafX2       (800*600, 16 Bit, RGB direct)    [EXCELLENT, with MMX]');{$ENDIF}
{$IFDEF GHX}{$DEFINE SELECT}WriteLn('5: GraphiX 7.3  (800*600, 16 Bit, RGB direct)    [GOOD, supplied by M. Knapp]');{$ENDIF}
	{$ENDIF}
{$IFDEF VESA}{$DEFINE SELECT}WriteLn('6: VESA         (select, 15/16 Bit, RGB direct)  [GOOD, reference driver #2]');{$ENDIF}
	ReadLn(I);
	case I of
	1: GUI.Driver:=@Drv_MCGA.Driver;
{$IFDEF BGI}2: GUI.Driver:=@Drv_BGI.Driver;{$ENDIF}
	{$IFNDEF DPMI}
{$IFDEF GX1}3: GUI.Driver:=@Drv_GX1.Driver;{$ENDIF}
	{$ELSE}
{$IFDEF GX2}4: GUI.Driver:=@Drv_GX2.Driver;{$ENDIF}
{$IFDEF GHX}5: GUI.Driver:=@Drv_GHX.Driver;{$ENDIF}
	{$ENDIF}
{$IFDEF VESA}6: GUI.Driver:=@Drv_VBE.Driver;{$ENDIF}
	else
		InOutRes:=0;
		WriteLn('No Driver selected!');
		Halt(1);
	end;
end;
{$ENDIF}

var
	App: TApp;
	{$IFDEF SHOWMEM}
	StartMem: Longint;
	{$ENDIF}

begin
	{$IFDEF SHOWMEM}
	StartMem:=MemAvail;
	{$ENDIF}
	{$IFDEF SELECT}
	SelectDriver;
	{$ELSE}
	{$IFDEF DPMI}
	{$IFDEF GX2}
	GUI.Driver:=@Drv_GX2.Driver;
	{$ELSE}{$IFDEF VESA}
	GUI.Driver:=@Drv_VBE.Driver;
	Drv_VBE.Resolution:=Point(800,600)^;
	{$ELSE}
	GUI.Driver:=@Drv_MCGA.Driver;
	{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF VESA}
	GUI.Driver:=@Drv_VBE.Driver;
	Drv_VBE.Resolution:=Point(800,600)^;
	{$ELSE}
	GUI.Driver:=@Drv_MCGA.Driver;
	{$ENDIF}{$ENDIF}
	{$ENDIF}
	App.Init;
	App.Run;
	App.Done;
	{$IFDEF DEBUG}
	WriteLn;
	WriteLn('GUI.'+Revision+'.BP Statistics');
	WriteLn('Maximal surfaces complexity: ',MaxRect,' rectangles per Surface');
	WriteLn('Total Surfaces used: ',UseTotal,' (',UseCount,' not closed)');
	WriteLn('Maximal open view count: ',MaxViews,' (',Views,' left open)');
	{$ENDIF}
	{$IFDEF SHOWMEM}
	WriteLn('Memory loss: ',Startmem-MemAvail,' bytes <waiting for enter>');
	ReadLn;
	{$ENDIF}
end.